<?php

/*----------------------------------------------------------------------------------|  simontech.me  |----/


				Award Manager - Public Edition 


/-------------------------------------------------------------------------------------------------------/





	@version		1.0.7


	@build			8th June, 2019


	@created		19th April, 2019


	@package		Award Manager


	@subpackage		nominees.php


	@author			SimonTech <https://simontech.me>	


	@copyright		Copyright (C) 2019 SimonTech Development. All Rights Reserved


	@license		GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html


  ____  _____  _____  __  __  __      __       ___  _____  __  __  ____  _____  _  _  ____  _  _  ____ 


 (_  _)(  _  )(  _  )(  \/  )(  )    /__\     / __)(  _  )(  \/  )(  _ \(  _  )( \( )( ___)( \( )(_  _)


.-_)(   )(_)(  )(_)(  )    (  )(__  /(__)\   ( (__  )(_)(  )    (  )___/ )(_)(  )  (  )__)  )  (   )(  


\____) (_____)(_____)(_/\/\_)(____)(__)(__)   \___)(_____)(_/\/\_)(__)  (_____)(_)\_)(____)(_)\_) (__) 





/------------------------------------------------------------------------------------------------------*/





// No direct access to this file


defined('_JEXEC') or die('Restricted access');





/**


 * Nominees Controller


 */


class Award_managerControllerNominees extends JControllerAdmin


{


	/**


	 * The prefix to use with controller messages.


	 *


	 * @var    string


	 * @since  1.6


	 */


	protected $text_prefix = 'COM_AWARD_MANAGER_NOMINEES';





	/**


	 * Method to get a model object, loading it if required.


	 *


	 * @param   string  $name    The model name. Optional.


	 * @param   string  $prefix  The class prefix. Optional.


	 * @param   array   $config  Configuration array for model. Optional.


	 *


	 * @return  JModelLegacy  The model.


	 *


	 * @since   1.6


	 */


	public function getModel($name = 'Nominee', $prefix = 'Award_managerModel', $config = array('ignore_request' => true))


	{


		return parent::getModel($name, $prefix, $config);


	}



	public function exportData()

	{

		// Check for request forgeries

		JSession::checkToken() or die(JText::_('JINVALID_TOKEN'));

		// check if export is allowed for this user.

		$user = JFactory::getUser();

		if ($user->authorise('nominee.export', 'com_award_manager') && $user->authorise('core.export', 'com_award_manager'))

		{

			// Get the input

			$input = JFactory::getApplication()->input;

			$pks = $input->post->get('cid', array(), 'array');

			// Sanitize the input

			JArrayHelper::toInteger($pks);

			// Get the model

			$model = $this->getModel('Nominees');

			// get the data to export

			$data = $model->getExportData($pks);

			if (Award_managerHelper::checkArray($data))

			{

				// now set the data to the spreadsheet

				$date = JFactory::getDate();

				Award_managerHelper::xls($data,'Nominees_'.$date->format('jS_F_Y'),'Nominees exported ('.$date->format('jS F, Y').')','nominees');

			}

		}

		// Redirect to the list screen with error.

		$message = JText::_('COM_AWARD_MANAGER_EXPORT_FAILED');

		$this->setRedirect(JRoute::_('index.php?option=com_award_manager&view=nominees', false), $message, 'error');

		return;

	}





	public function importData()

	{

		// Check for request forgeries

		JSession::checkToken() or die(JText::_('JINVALID_TOKEN'));

		// check if import is allowed for this user.

		$user = JFactory::getUser();

		if ($user->authorise('nominee.import', 'com_award_manager') && $user->authorise('core.import', 'com_award_manager'))

		{

			// Get the import model

			$model = $this->getModel('Nominees');

			// get the headers to import

			$headers = $model->getExImPortHeaders();

			if (Award_managerHelper::checkObject($headers))

			{

				// Load headers to session.

				$session = JFactory::getSession();

				$headers = json_encode($headers);

				$session->set('nominee_VDM_IMPORTHEADERS', $headers);

				$session->set('backto_VDM_IMPORT', 'nominees');

				$session->set('dataType_VDM_IMPORTINTO', 'nominee');

				// Redirect to import view.

				$message = JText::_('COM_AWARD_MANAGER_IMPORT_SELECT_FILE_FOR_NOMINEES');

				$this->setRedirect(JRoute::_('index.php?option=com_award_manager&view=import', false), $message);

				return;

			}

		}

		// Redirect to the list screen with error.

		$message = JText::_('COM_AWARD_MANAGER_IMPORT_FAILED');

		$this->setRedirect(JRoute::_('index.php?option=com_award_manager&view=nominees', false), $message, 'error');

		return;

	}


}


